from rocolib.api.components import Component

c = Component()

c.addSubcomponent("top", "UChannel")
c.addSubcomponent("front", "Rectangle")
c.addSubcomponent("back", "Rectangle")
c.addSubcomponent("splittop", "SplitEdge")

c.addParameter("toplength", 55, paramType="length")
c.addParameter("topwidth", 35, paramType="length")
c.addParameter("topdepth", 20, paramType="length")
c.addParameter("bangle", 90, paramType="angle")
c.addParameter("tangle", 45, paramType="angle")

c.addConstraint(("top", "length"), "toplength")
c.addConstraint(("top", "width"), "topwidth")
c.addConstraint(("top", "depth"), "topdepth")
c.addConstraint(("top", "bangle"), "bangle")
c.addConstraint(("top", "tangle"), "tangle")
c.addConstraint(("front", "l"), "topwidth")
c.addConstraint(("front", "w"), "topdepth", "x * 1.4142") #1.4142 is sqrt(2)
c.addConstraint(("back", "l"), "topwidth")
c.addConstraint(("back", "w"), "topdepth")
c.addConstraint(("splittop", "toplength"), "topwidth", "(x,)")
c.addConstraint(("splittop", "botlength"), "topwidth", "((x - 30)/2., x - (x - 30), (x - 30)/2.)")

c.addConnection(("top", "topedge2"), ("front", "l"), angle=90)
c.addConnection(("top", "topedge0"), ("front", "r"), angle=90, tabWidth=5)
c.addConnection(("top", "botedge1"), ("back", "t"), angle=90)
c.addConnection(("top", "botedge2"), ("back", "r"), angle=90, tabWidth=5)
c.addConnection(("top", "botedge0"), ("back", "l"), angle=90, tabWidth=5)

c.addConnection(("splittop", "topedge0"), ("back", "b"))
c.inheritInterface("backedge", ("splittop", "botedge1"))
c.inheritInterface("ledge", ("top", "ledge"))
c.inheritInterface("redge", ("top", "redge"))

c.toLibrary("TankTop")