from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addParameter("depth", 60, parameterType="length") # = boat depth
c.addParameter("width", 90, parameterType="length") # = boat depth

c.addSubcomponent("servoMount", "SideServoMount", inherit="depth")

c.addSubcomponent("leftArmDown", "Rectangle")
c.addConstConstraint(("leftArmDown", "w"), 24)
c.addConstraint(("leftArmDown", "l"), "depth", "x-3") #DEPTH OF BOAT - 3 for the tab

c.addSubcomponent("leftArmAcross", "Rectangle")
c.addConstConstraint(("leftArmAcross", "w"), 24)
c.addConstraint(("leftArmAcross", "l"), ("width", "servoMount.depth"), "x[0]/2 - x[1]/2") #DEPTH OF BOAT - 3 for the tab

c.addConnection(("leftArmDown", "r"), ("leftArmAcross", "r"), angle=-90)

c.addSubcomponent("rightArmDown", "Rectangle")
c.addConstConstraint(("rightArmDown", "w"), 24)
c.addConstraint(("rightArmDown", "l"), "depth", "x-3") #DEPTH OF BOAT

c.addSubcomponent("rightArmAcross", "Rectangle")
c.addConstConstraint(("rightArmAcross", "w"), 24)
c.addConstraint(("rightArmAcross", "l"), ("width", "servoMount.depth"), "x[0]/2 - x[1]/2") #DEPTH OF BOAT - 3 for the tab

c.addConnection(("rightArmDown", "r"), ("rightArmAcross", "r"), angle=-90)

c.addConnection(("servoMount", "leftInterface"), ("leftArmAcross", "l")) #l/r, not t/b
c.addConnection(("servoMount", "rightInterface"), ("rightArmAcross", "l"))

c.inheritInterface("leftArmInterface", ("leftArmDown", "l"))
c.inheritInterface("rightArmInterface", ("rightArmDown", "l"))

c.toLibrary("ServoMountWithArms")
